gi-gtk4-4.0.12: Gtk 4.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.TextMark

Contents

- Exported types
- Methods
  - getBuffer
  - getDeleted
  - getLeftGravity
  - getName
  - getVisible
  - new
  - setVisible
- Properties
  - leftGravity
  - name

Description

Marks a position in a `GtkTextbuffer` that is preserved across modifications.

You may wish to begin by reading the text widget conceptual overview, which gives an overview of all the objects and data types related to the text widget and how they work together.

A `GtkTextMark` is like a bookmark in a text buffer; it preserves a position in the text. You can convert the mark to an iterator using `textBufferGetIterAtMark`. Unlike iterators, marks remain valid across buffer mutations, because their behavior is defined when text is inserted or deleted. When text containing a mark is deleted, the mark remains in the position originally occupied by the deleted text. When text is inserted at a mark, a mark with “left gravity” will be moved to the beginning of the newly-inserted text, and a mark with “right gravity” will be moved to the end.

Note that “left” and “right” here refer to logical direction (left is the toward the start of the buffer); in some languages such as Hebrew the logically-leftmost text is not actually on the left when displayed.

Marks are reference counted, but the reference count only controls the validity of the memory; marks can be deleted from the buffer at any time with `textBufferDeleteMark`. Once deleted from the buffer, a mark is essentially useless.

Marks optionally have names; these can be convenient to avoid passing the `GtkTextMark` object around.

Marks are typically created using the `textBufferCreateMark` function.

Synopsis

- newtype TextMark = TextMark (ManagedPtr TextMark)
- class (GObject o, IsDescendantOf TextMark o) => IsTextMark o
- toTextMark :: (MonadIO m, IsTextMark o) => o -> m TextMark
- textMarkGetBuffer :: (HasCallStack, MonadIO m, IsTextMark a) => a -> m (Maybe TextBuffer)
- textMarkGetDeleted :: (HasCallStack, MonadIO m, IsTextMark a) => a -> m Bool
- textMarkGetLeftGravity :: (HasCallStack, MonadIO m, IsTextMark a) => a -> m Bool
- textMarkGetName :: (HasCallStack, MonadIO m, IsTextMark a) => a -> m (Maybe Text)
- textMarkGetVisible :: (HasCallStack, MonadIO m, IsTextMark a) => a -> m Bool
- textMarkNew :: (HasCallStack, MonadIO m) => Maybe Text -> Bool -> m TextMark
- textMarkSetVisible :: (HasCallStack, MonadIO m, IsTextMark a) => a -> Bool -> m ()
- constructTextMarkLeftGravity :: (IsTextMark o, MonadIO m) => Bool -> m (GValueConstruct o)
- getTextMarkLeftGravity :: (MonadIO m, IsTextMark o) => o -> m Bool
- constructTextMarkName :: (IsTextMark o, MonadIO m) => Text -> m (GValueConstruct o)
- getTextMarkName :: (MonadIO m, IsTextMark o) => o -> m (Maybe Text)

# Exported types

newtype TextMark Source #

Memory-managed wrapper type.

Constructors

TextMark (ManagedPtr TextMark) |

#### Instances

Instances details

Eq TextMark Source # |
Instance details Defined in GI.Gtk.Objects.TextMark Methods (==) :: TextMark -> TextMark -> Bool Source # (/=) :: TextMark -> TextMark -> Bool Source #
GObject TextMark Source # |
Instance details Defined in GI.Gtk.Objects.TextMark
ManagedPtrNewtype TextMark Source # |
Instance details Defined in GI.Gtk.Objects.TextMark Methods toManagedPtr :: TextMark -> ManagedPtr TextMark Source #
TypedObject TextMark Source # |
Instance details Defined in GI.Gtk.Objects.TextMark Methods glibType :: IO GType Source #
HasParentTypes TextMark Source # |
Instance details Defined in GI.Gtk.Objects.TextMark
IsGValue (Maybe TextMark) Source # | Convert `TextMark` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.TextMark Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe TextMark -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe TextMark) Source #
type ParentTypes TextMark Source # |
Instance details Defined in GI.Gtk.Objects.TextMark type ParentTypes TextMark = '[Object]

class (GObject o, IsDescendantOf TextMark o) => IsTextMark o Source #

Type class for types which can be safely cast to `TextMark`, for instance with `toTextMark`.

#### Instances

Instances details

(GObject o, IsDescendantOf TextMark o) => IsTextMark o Source # |
Instance details Defined in GI.Gtk.Objects.TextMark

toTextMark :: (MonadIO m, IsTextMark o) => o -> m TextMark Source #

Cast to `TextMark`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, ref, refSink, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getBuffer, getData, getDeleted, getLeftGravity, getName, getProperty, getQdata, getVisible.

#### Setters

setData, setDataFull, setProperty, setVisible.

## getBuffer

textMarkGetBuffer Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextMark a) |
=> a | `mark`: a `GtkTextMark`
-> m (Maybe TextBuffer) | Returns: the mark’s `GtkTextBuffer`

Gets the buffer this mark is located inside.

Returns `Nothing` if the mark is deleted.

## getDeleted

textMarkGetDeleted Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextMark a) |
=> a | `mark`: a `GtkTextMark`
-> m Bool | Returns: whether the mark is deleted

Returns `True` if the mark has been removed from its buffer.

See `textBufferAddMark` for a way to add it to a buffer again.

## getLeftGravity

textMarkGetLeftGravity Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextMark a) |
=> a | `mark`: a `GtkTextMark`
-> m Bool | Returns: `True` if the mark has left gravity, `False` otherwise

Determines whether the mark has left gravity.

## getName

textMarkGetName Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextMark a) |
=> a | `mark`: a `GtkTextMark`
-> m (Maybe Text) | Returns: mark name

Returns the mark name.

Returns `Nothing` for anonymous marks.

## getVisible

textMarkGetVisible Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextMark a) |
=> a | `mark`: a `GtkTextMark`
-> m Bool | Returns: `True` if visible

Returns `True` if the mark is visible.

A cursor is displayed for visible marks.

## new

textMarkNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Maybe Text | `name`: mark name
-> Bool | `leftGravity`: whether the mark should have left gravity
-> m TextMark | Returns: new `GtkTextMark`

Creates a text mark.

Add it to a buffer using `textBufferAddMark`. If `name` is `Nothing`, the mark is anonymous; otherwise, the mark can be retrieved by name using `textBufferGetMark`. If a mark has left gravity, and text is inserted at the mark’s current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity (`leftGravity` = `False`), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you’re typing).

## setVisible

textMarkSetVisible Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextMark a) |
=> a | `mark`: a GtkTextMark
-> Bool | `setting`: visibility of mark
-> m () |

Sets the visibility of `mark`.

The insertion point is normally visible, i.e. you can see it as a vertical bar. Also, the text widget uses a visible mark to indicate where a drop will occur when dragging-and-dropping text. Most other marks are not visible.

Marks are not visible by default.

# Properties

## leftGravity

Whether the mark has left gravity.

When text is inserted at the mark’s current location, if the mark has left gravity it will be moved to the left of the newly-inserted text, otherwise to the right.

constructTextMarkLeftGravity :: (IsTextMark o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`left-gravity`” property. This is rarely needed directly, but it is used by `new`.

getTextMarkLeftGravity :: (MonadIO m, IsTextMark o) => o -> m Bool Source #

Get the value of the “`left-gravity`” property. When overloading is enabled, this is equivalent to

    get textMark #leftGravity

## name

The name of the mark or `Nothing` if the mark is anonymous.

constructTextMarkName :: (IsTextMark o, MonadIO m) => Text -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`name`” property. This is rarely needed directly, but it is used by `new`.

getTextMarkName :: (MonadIO m, IsTextMark o) => o -> m (Maybe Text) Source #

Get the value of the “`name`” property. When overloading is enabled, this is equivalent to

    get textMark #name